unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, dbf, DB, Forms, Controls, Graphics, Dialogs, DBGrids, Grids;

type

  { TForm1 }

  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Dbf1: TDbf;
    DBGrid1: TDBGrid;
    procedure DBGrid1DrawColumnTitle(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  TypInfo, LCLIntf;

{ TForm1 }

type
  TDBGridAccess = class(TDBGrid);

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  Dbf1.FilePathFull := Application.Location;
  Dbf1.TableName := 'animals.dbf';
  if FileExists(Dbf1.FilePathFull + Dbf1.TableName) then
    Dbf1.Active := true
  else
  begin
    Showmessage('DBF file not found.');
    exit;
  end;

  for i := 0 to DBGrid1.Columns.Count-1 do
    with DBGrid1.Columns[i] do
      Title.Caption := '';     // we draw the title on our own

  TDBGridAccess(DBGrid1).RowHeights[0] := 2* DBGrid1.DefaultRowHeight;
end;

procedure TForm1.DBGrid1DrawColumnTitle(Sender: TObject; const Rect: TRect;
  DataCol: Integer; Column: TColumn; State: TGridDrawState);
var
  ts: TTextStyle;
  s: String;
  R: TRect;
begin
  ts := DBGrid1.Canvas.TextStyle;
  ts.WordBreak := true;
  ts.SingleLine := false;
  ts.Layout := tlCenter;
  ts.Alignment := Column.Title.Alignment;
  DBGrid1.Canvas.TextStyle := ts;
  s := GetEnumName(TypeInfo(TFieldType), Integer(Column.Field.DataType));
  Delete(s, 1, 2);
  if Column.Field.DataType in [ftString, ftWideString] then
    s := Format('%s (%d)', [s, Column.Field.Size]);
  R := Rect;
  InflateRect(R, -varCellPadding, -varCellPadding);
  DBGrid1.Canvas.TextRect(R, R.Left, R.Top, Column.FieldName + LineEnding + s);
end;

end.

